window.onload = function () {
  var spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss'), {
    sheetCount: 2,
  });
  initSpread(spread);
};

function initSpread(spread) {
  var asyncSum = function () {};
  asyncSum.prototype = new GC.Spread.CalcEngine.Functions.AsyncFunction(
    'ASUM',
    1,
    255
  );
  asyncSum.prototype.defaultValue = function () {
    return 'Loading...';
  };
  asyncSum.prototype.evaluateAsync = function (context) {
    debugger;
    // use setTimeout to simulate server side evaluation
    // in read world it maybe an ajax post to server for evaluation
    var args = arguments;
    setTimeout(function () {
      var result = 0;
      for (var i = 1; i < args.length; i++) {
        result += args[i];
      }
      context.setAsyncResult(result);
    }, 500);
  };

  var sheet = spread.sheets[0];
  sheet.options.allowCellOverflow = true;

  sheet.setArray(0, 0, [[5, 15]]);
  sheet.addCustomFunction(new asyncSum());

  sheet.setFormula(
    1,
    1,
    'ASUM(A1,B1)+ASUM(A1,B1)+ASUM(A1,B1)+ASUM(A1,B1)+ASUM(A1,B1)'
  ); // 5 call to ASUM can lead to 10 or even more 20+ call to the asyncSum.evaluateAsync function
}
